<?php


namespace app\admin\controller;


use think\App;
use think\facade\Validate;
use think\facade\Db;
class Login extends Base{
		public function __construct(App $app) {parent::__construct($app);}

		public function login(){
			 $post=$this->request->only(["username"=>"","password"=>""],"post","trim");
			 $valid=Validate::rule([
			    "username|账户"=>"require|max:255",
			    "password|密码"=>"require|max:255"
			    ]);
			 if($valid->check($post)==false)return error_show(1004,$valid->getError());
			 $useinfo =checkLogin($post);
			 if(!isset($useinfo['code'])|| $useinfo['code']!=0){
			    return error_show(1004,$useinfo['message']);
			 }
			 $role =Db::name("user_role")->where(["uid"=>$useinfo['data']['id'],"is_main"=>1,"is_del"=>0])->findOrEmpty();
			 if(!empty($role)){
			 	$company_name = Db::name("supplier_info")->where(["code"=>$role['companyNo']])->value("name","");
			 	$roleinfo = Db::name("role")->where(["id"=>$role['roleid']])->field("role_name,level")->find();
			 }else{
			 	 return error_show(1004,'未开通登录权限');
			 }
			 $user =$useinfo["data"]??[];
			 $user['role_name']=$roleinfo['role_name']??'';
			 $user['company_name']=$company_name??'';
			 $user['role_level']=$roleinfo['level']??'';
			 $user['role_id']=$role['roleid']??'';
			 $user['companyNo']=$role['companyNo']??'';
			 $user['company_type']=$role['company_type']??'';
			 return app_show(0,"登录成功",$user);
		}


}